/**
 * Created by akira on 3/30/17.
 */
"use strict";
angular.module('app.directive',[])
    .controller('settingController', settingController)
    .directive('settingDirective',settingDirective);

settingController.$inject = ['$scope'];
function settingController ($scope) {
    utils.resetClickHandler($('#link_setting , .p_setting'), function (e) {
        e.stopPropagation();
        _gaq.push(['_trackEvent', config_app + ' Click', 'Setting','Setting']);
        $('#topsites_menu').fadeOut(200);
        $('#setting_menu').toggle(200);
        $('#support_menu').fadeOut(200);
        $('#share_menu').fadeOut(200);

    });

    if (localStorage.getItem('_wpd') == undefined && localStorage.getItem('_wpd') == null && localStorage.getItem('_old') == undefined && localStorage.getItem('_old') == null  ) {
        localStorage.setItem('_wpd',5);
        localStorage.setItem('_old',5);
        setStartDate(5);
    }


    utils.customizePerDay('_pads',_.range(20,23),function (response) {
        if (response) {
            console.log('success');
        }
    });

    utils.resetClickHandler($('#click-three'), function (e) {
        e.stopPropagation();
        if (!$('.click-three').hasClass('checked')) {
            $('.click-three').addClass('checked');
            if (localStorage.getItem('_old') == 10) {
                localStorage.setItem('_ne',(JSON.parse(localStorage.getItem('_ne')) - 7));
                localStorage.setItem('_nekj',(JSON.parse(localStorage.getItem('_nekj')) - 7));
                localStorage.setItem('_nehk',(JSON.parse(localStorage.getItem('_nehk')) - 7));
                localStorage.setItem('_neph',(JSON.parse(localStorage.getItem('_neph')) - 7));
            }
            if (localStorage.getItem('_old') == 5) {
                localStorage.setItem('_ne',(JSON.parse(localStorage.getItem('_ne')) - 2));
                localStorage.setItem('_nekj',(JSON.parse(localStorage.getItem('_nekj')) - 2));
                localStorage.setItem('_nehk',(JSON.parse(localStorage.getItem('_nehk')) - 2));
                localStorage.setItem('_neph',(JSON.parse(localStorage.getItem('_neph')) - 2));
            }
        }
        _gaq.push(['_trackEvent', config_app + ' Click', 'Số từ muốn học','3 từ']);
        localStorage.setItem('_wpd',3);
        localStorage.setItem('_old',3);
        setStartDate(3);
        $('.click-five').removeClass('checked');
        $('.click-ten').removeClass('checked');
        $('.click-many').removeClass('checked');
    });

    utils.resetClickHandler($('#click-five'), function (e) {
        e.stopPropagation();
        if (!$('.click-five').hasClass('checked')) {
            $('.click-five').addClass('checked');
            if (localStorage.getItem('_old') == 10) {
                localStorage.setItem('_ne',(JSON.parse(localStorage.getItem('_ne')) - 5));
                localStorage.setItem('_nekj',(JSON.parse(localStorage.getItem('_nekj')) - 5));
                localStorage.setItem('_nehk',(JSON.parse(localStorage.getItem('_nehk')) - 5));
                localStorage.setItem('_neph',(JSON.parse(localStorage.getItem('_neph')) - 5));
            }
            if (localStorage.getItem('_old') == 3) {
                localStorage.setItem('_ne',(JSON.parse(localStorage.getItem('_ne')) + 2));
                localStorage.setItem('_nekj',(JSON.parse(localStorage.getItem('_nekj')) + 2));
                localStorage.setItem('_nehk',(JSON.parse(localStorage.getItem('_nehk')) + 2));
                localStorage.setItem('_neph',(JSON.parse(localStorage.getItem('_neph')) + 2));
            }
        }
        _gaq.push(['_trackEvent', config_app + ' Click', 'Số từ muốn học','5 từ']);
        localStorage.setItem('_wpd',5);
        localStorage.setItem('_old',5);
        setStartDate(5);
        $('.click-three').removeClass('checked');
        $('.click-ten').removeClass('checked');
        $('.click-many').removeClass('checked');
    });

    utils.resetClickHandler($('#click-ten'), function (e) {
        e.stopPropagation();
        if (!$('.click-ten').hasClass('checked')) {
            $('.click-ten').addClass('checked');
            if (localStorage.getItem('_old') == 5) {
                localStorage.setItem('_ne',(JSON.parse(localStorage.getItem('_ne')) + 5));
                localStorage.setItem('_nekj',(JSON.parse(localStorage.getItem('_nekj')) + 5));
                localStorage.setItem('_nehk',(JSON.parse(localStorage.getItem('_nehk')) + 5));
                localStorage.setItem('_neph',(JSON.parse(localStorage.getItem('_neph')) + 5));
            }
            if (localStorage.getItem('_old') == 3) {
                localStorage.setItem('_ne',(JSON.parse(localStorage.getItem('_ne')) + 7));
                localStorage.setItem('_nekj',(JSON.parse(localStorage.getItem('_nekj')) + 7));
                localStorage.setItem('_nehk',(JSON.parse(localStorage.getItem('_nehk')) + 7));
                localStorage.setItem('_neph',(JSON.parse(localStorage.getItem('_neph')) + 7));
            }

        }
        setStartDate(10);
        _gaq.push(['_trackEvent', config_app + ' Click', 'Số từ muốn học','10 từ']);
        localStorage.setItem('_wpd',10);
        localStorage.setItem('_old',10);
        $('.click-three').removeClass('checked');
        $('.click-five').removeClass('checked');
        $('.click-many').removeClass('checked');
    });

    utils.resetClickHandler($('#click-many'), function (e) {
        e.stopPropagation();
        if (!$('.click-many').hasClass('checked')) {
            $('.click-many').addClass('checked');
        }
        _gaq.push(['_trackEvent', config_app + ' Click', 'Số từ muốn học','nhiều từ']);
        localStorage.setItem('_wpd',100);
        $('.click-three').removeClass('checked');
        $('.click-ten').removeClass('checked');
        $('.click-five').removeClass('checked');
    });

    utils.resetClickHandler($('#click-new_word'), function (e) {
        e.stopPropagation();
        if ($('.click-new_word').hasClass('checked')) {
            $('.click-new_word').removeClass("checked");
            _gaq.push(['_trackEvent', config_app + ' Click', 'Những kiến thức bạn muốn học','Turn off word']);
            $scope.enable.word = 0;
        } else {
            $('.click-new_word').addClass("checked");
            _gaq.push(['_trackEvent', config_app + ' Click', 'Những kiến thức bạn muốn học','Turn on word']);
            $scope.enable.word = 1;
        }
        updateEnable()
    });
    utils.resetClickHandler($('#click-kanji'), function (e) {
        e.stopPropagation();
        if ($('.click-kanji').hasClass('checked')) {
            $('.click-kanji').removeClass("checked");
            _gaq.push(['_trackEvent', config_app + ' Click', 'Những kiến thức bạn muốn học','Turn off Kanji']);
            $scope.enable.kanji = 0;
        } else {
            $('.click-kanji').addClass("checked");
            _gaq.push(['_trackEvent', config_app + ' Click', 'Những kiến thức bạn muốn học','Turn on Kanji']);
            $scope.enable.kanji = 1;
        }
        updateEnable();
    });
    utils.resetClickHandler($('#click-hiragana'), function (e) {
        e.stopPropagation();
        if ($('.click-hiragana').hasClass('checked')) {
            $('.click-hiragana').removeClass("checked");
            _gaq.push(['_trackEvent', config_app + ' Click', 'Những kiến thức bạn muốn học','Turn off Hiragana']);
            $scope.enable.hiragana = 0;
        } else {
            $('.click-hiragana').addClass("checked");
            _gaq.push(['_trackEvent', config_app + ' Click', 'Những kiến thức bạn muốn học','Turn on Hiragana']);
            $scope.enable.hiragana = 1;
        }
        updateEnable();
    });
    utils.resetClickHandler($('#click-katakana'), function (e) {
        e.stopPropagation();
        if ($('.click-katakana').hasClass('checked')) {
            $('.click-katakana').removeClass("checked");
            _gaq.push(['_trackEvent', config_app + ' Click', 'Những kiến thức bạn muốn học','Turn off Katakana']);
            $scope.enable.katakana = 0;
        } else {
            $('.click-katakana').addClass("checked");
            _gaq.push(['_trackEvent', config_app + ' Click', 'Những kiến thức bạn muốn học','Turn on Katakana']);
            $scope.enable.katakana = 1;
        }
        updateEnable();
    });

    utils.resetClickHandler($('#click-phrase'), function (e) {
        e.stopPropagation();
        if ($('.click-phrase').hasClass('checked')) {
            $('.click-phrase').removeClass("checked");
            _gaq.push(['_trackEvent', config_app + ' Click', 'Những kiến thức bạn muốn học','Turn off Phrase']);
            $scope.enable.phrase = 0;
        } else {
            $('.click-phrase').addClass("checked");
            _gaq.push(['_trackEvent', config_app + ' Click', 'Những kiến thức bạn muốn học','Turn on Phrase']);
            $scope.enable.phrase = 1;
        }
        updateEnable();
    });

    var _wpd = localStorage.getItem('_wpd');
    if (_wpd != null && _wpd != undefined ) {
        $scope.isChecked = _wpd;
        $scope.display_none = true;
    }

    function updateEnable() {
        localStorage.setItem('enable',JSON.stringify($scope.enable))
    }

    function setStartDate(number) {

        var _start = localStorage.getItem('_start');
        var _ns = localStorage.getItem('_ns');
        var _ne = localStorage.getItem('_ne');
        if (_start == null && _start == undefined ) {
            var a = new Date();
            a = (a.getMonth() + 1)  + '/' + a.getDate() + '/' + a.getFullYear()
            localStorage.setItem('_start', a);
            localStorage.setItem('_ns', 0);
            localStorage.setItem('_ne', number);
            localStorage._nskj = 0;
            localStorage._nekj = number;
            localStorage._nshk = 0;
            localStorage._nehk = number;
            localStorage._nsph = 0;
            localStorage._neph = number;
        }
    }

    $('setting-directive').off('mouseleave');
    $('setting-directive').on('mouseleave', hide);
    function hide() {
        $('#setting_menu').fadeOut(200);
    }
}
settingDirective.$inject = [];
function settingDirective () {
    function link(scope, element, attrs) {
        element.ready(function () {

        });
    }
    return {
        link : link,
        restrict: 'EA',
        scope: {
            'enable' : '='
        },
        templateUrl: '/js/directives/setting.html',
        controller: 'settingController'
    };
}
