// Elight Extension Event Page
(function () {

    if (chrome && chrome.runtime && chrome.runtime.setUninstallURL) {
        chrome.runtime.setUninstallURL("https://akirademy.com/?utm_source=extension&utm_medium=uninstall&utm_campaign=AkiraUS");
    }

    chrome.runtime.onInstalled.addListener(function (details) {
        if (details && details.reason && details.reason == 'install') {
            chrome.tabs.create({url: "index.html"});
            chrome.tabs.create({url: "https://akirademy.com/?utm_source=extension&utm_medium=install&utm_campaign=AkiraUS"});
        }
    });

    chrome.browserAction.onClicked.addListener(function (tab) {
        chrome.tabs.create({url: "index.html"});
    });
})();
