/**
 * Created by akira on 3/30/17.
 */
"use strict";
angular.module('app.service',[])
    .service('mainService', mainService);
mainService.$inject = ['$http'];
function mainService($http) {
    var service = {};
    service.search = function (key_word, callback) {
        if (key_word == "") {
            callback({status : 400})
        } else {
            $http({
                method: 'GET',
                url: "https://www.google.com/complete/search",
                params: {
                    client: "firefox",
                    ie: "utf-8",
                    oe: "utf-8",
                    hl: "en-US",
                    gl: "",
                    q: key_word == "" ? "" : key_word
                }
            }).then(function successCallback(response) {
                callback(response);
            }, function errorCallback(response) {
                callback(response);
            });
        }
    };
    service.getWeather = function (key_word, callback) {
        var searchtext = "select item.condition from weather.forecast where woeid in (select woeid from geo.places(1) where text='"+key_word.address+","+key_word.city+"') and u='c'";
        $http({
            method: 'GET',
            url: "https://query.yahooapis.com/v1/public/yql",
            params: {
                q: searchtext,
                format : "json"
            }
        }).then(function successCallback(response) {
            callback(response);
        }, function errorCallback(response) {
            callback(response);
        });
    };

    service.getCityFromLatlong = function (lat, long, callback) {
        $http({
            method: 'GET',
            url: 'https://maps.google.com/maps/api/geocode/json',
            params: {
                latlng: lat+','+long,
                sensor : true
            }
        }).then(function successCallback(response) {
            callback(response.data);
        }, function errorCallback(response) {
            callback(response.data);
        });
    };
    return service;
}